#include<iostream>
#include<cstdlib>
#include<ctime>
#define MAX_SIZE 100000
using namespace std;

//ϴ value  ã ˰ log n ⵵ ´.
// Ǿִ  ϴ.

//ǥ
int BinarySearch_Recursion(int arr[], int l, int r, int key) {
	int mid = (l + r) / 2;

	if (l <= r) {
		if (key == arr[mid])
			return mid;

		if (arr[mid] > key)
			return BinarySearch_Recursion(arr, l, mid - 1, key);

		return BinarySearch_Recursion(arr, mid+1, r, key);
	}

	return -1;
}

//loop ̿
int BinarySearch_loop(int arr[], int l, int r, int key) {
	while (l <= r) {
		int mid = (l + r) / 2;
		if (key == arr[mid])
			return mid;

		if (arr[mid] > key) {
			r = mid - 1;
		}
		else {
			l = mid + 1;
		}
	}
	return -1;
}



int main() {
	int arr[MAX_SIZE];

	for (int i = 0; i < MAX_SIZE; i++) {
		arr[i] = i + 1;
	}

	srand((unsigned int)time(NULL));
	int key = rand() % MAX_SIZE + 1;

	clock_t begin, end;
	cout << "ϰ ϴ  : " << key << endl;


	cout << "\nBinarySerch_Recursion-----------" << endl;
	begin = clock();
	int res = BinarySearch_Recursion(arr, 0, MAX_SIZE - 1, key);
	end = clock();
	cout << res << "° ε" << endl;
	cout << "ð : " << (end - begin) / CLOCKS_PER_SEC << endl;

	cout << "\nBinarySerch_Loop-----------" << endl;
	begin = clock();
	res = BinarySearch_loop(arr, 0, MAX_SIZE - 1, key);
	end = clock();
	cout << res << "° ε" << endl;
	cout << "ð : " << (end - begin) /CLOCKS_PER_SEC << endl;

	return 0;
}